Subject: Re: [PATCH] net: can: Remodel FlexCAN register read/write APIs for BE instances

From: Marc Kleine-Budde <[email-masked]>
Date: Wed, 25 Jun 2014 21:00:12 +0200

On 06/25/2014 04:16 PM, [email-masked] wrote:
>> -----Original Message-----
>> From: Marc Kleine-Budde [mailto:[email-masked]]
>> Sent: Wednesday, June 25, 2014 4:38 PM
>> To: Sharma Bhupesh-B45370; [email-masked]
>> Cc: [email-masked]; [email-masked]
>> Subject: Re: [PATCH] net: can: Remodel FlexCAN register read/write APIs
>> for BE instances
>>
>> On 06/25/2014 01:01 PM, [email-masked] wrote:
>>>> What about function pointers in the priv? So that flexcan_read()
>>>> becomes
>>>> priv->read().
>>
>>> That's what I propose (similar to what I did for C_CAN driver for
>>> 16-bit and 32-bit reg interfaces using platform data):
>>
>> Yes...but...
>>
>>> bool module_is_be = false;
>>
>> ...module_is_be is not that simple, on PPC true must be the default to be
>> compatible with existing dts.
> 
> How does this look (a bit messed up, so I am open for comments):

What about:

static u32 flexcan_read_le(void __iomem *addr)
{
	return ioread32(addr);
}

static u32 flexcan_read_be(void __iomem *addr)
{
	return ioread32be(addr);
}

flexcan_probe ()
{
	bool core_is_little = true;

	/* or #ifdef __BIG_ENDIAN ... #endif instead of IS_ENABLED() */
	if (IS_ENABLED(CONFIG_CPU_BIG_ENDIAN) ||
	    of_property_read_bool(dev->dev.of_node, "big-endian"))
		core_is_little = false;

	if (core_is_little)
		priv->read = flexcan_read_le;
	else
		priv->read = flexcan_read_be;

}

Marc

-- 
Pengutronix e.K.                  | Marc Kleine-Budde           |
Industrial Linux Solutions        | Phone: +49-231-2826-924     |
Vertretung West/Dortmund          | Fax:   +49-5121-206917-5555 |
Amtsgericht Hildesheim, HRA 2686  | http://www.pengutronix.de   |